package com.smcic.api.admin.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.smcic.api.admin.dto.NamePageDTO;
import com.smcic.api.admin.entity.AdminRole;
import com.smcic.api.admin.service.impl.AdminRoleServiceImpl;
import com.smcic.core.auth.LoginRequired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * <p>
 * 管理员角色 前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@RestController
@RequestMapping("/admin/role")
public class AdminRoleController {

    @Resource
    private AdminRoleServiceImpl adminRoleService;

    @PostMapping("/list")
    @LoginRequired
    public Page<AdminRole> rolePage(@RequestBody NamePageDTO namePageDTO){
        return adminRoleService.rolePage(namePageDTO);
    }

    @PostMapping("/add")
    @LoginRequired
    public void addRole(@RequestBody AdminRole adminRole){
        adminRoleService.create(adminRole);
    }

    @DeleteMapping("/delete/{id}")
    @LoginRequired
    public void deleteRole(@PathVariable Long id){
        adminRoleService.delete(id);
    }

    @PostMapping("/update")
    @LoginRequired
    public void updateRole(@RequestBody AdminRole adminRole){
        adminRoleService.modify(adminRole);
    }

    @GetMapping("/info/{id}")
    @LoginRequired
    public AdminRole getRole(@PathVariable Long id){
        return adminRoleService.info(id);
    }

}
