package com.smcic.api.admin.controller;


import com.google.common.collect.ImmutableMap;
import com.smcic.api.admin.entity.NetworkMedia;
import com.smcic.api.admin.service.impl.NetworkMediaServiceImpl;
import com.smcic.core.auth.LoginRequired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 网媒管理 前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@RestController
@RequestMapping("/admin/network-media")
public class NetworkMediaController {

    @Resource
    private NetworkMediaServiceImpl networkMediaService;

    @GetMapping("/list")
    public List<NetworkMedia> list() {
        return networkMediaService.list();
    }

    @PostMapping("/add")
    @LoginRequired
    public void add(@RequestBody NetworkMedia networkMedia) {
        networkMediaService.add(networkMedia);
    }

    @PostMapping("/update")
    @LoginRequired
    public void update(@RequestBody NetworkMedia networkMedia) {
        networkMediaService.update(networkMedia);
    }

    @DeleteMapping("/delete/{id}")
    @LoginRequired
    public void delete(@PathVariable Long id) {
        networkMediaService.removeById(id);
    }

    @RequestMapping("upload")
    @LoginRequired
    public Map<String, String> upload(@RequestParam(value = "file", required = false) MultipartFile file){
        return ImmutableMap.of("url", networkMediaService.upload(file));
    }

}
