package com.smcic.api.admin.controller;


import com.smcic.api.admin.dto.UserRoleDTO;
import com.smcic.api.admin.service.impl.UserRoleServiceImpl;
import com.smcic.core.auth.LoginRequired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 * 管理员角色 前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@RestController
@RequestMapping("/admin/user-role")
public class UserRoleController {

    @Resource
    private UserRoleServiceImpl userRoleService;

    @GetMapping("/list")
    @LoginRequired
    public List<UserRoleDTO> list(){
        return userRoleService.userRoles();
    }

    @PostMapping("/add")
    @LoginRequired
    public void add(@RequestBody UserRoleDTO userRoleDTO){
        userRoleService.create(userRoleDTO);
    }

    @PostMapping("/update")
    @LoginRequired
    public void update(@RequestBody UserRoleDTO userRoleDTO){
        userRoleService.modify(userRoleDTO);
    }

    @DeleteMapping("/delete/{id}")
    @LoginRequired
    public void delete(@PathVariable Long id){
        userRoleService.del(id);
    }

}
