package com.smcic.api.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.smcic.api.admin.dto.NamePageDTO;
import com.smcic.api.admin.entity.LifeService;
import com.smcic.api.admin.mapper.LifeServiceMapper;
import com.smcic.api.admin.service.ILifeServiceService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.smcic.core.advice.APIException;
import org.apache.http.util.TextUtils;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@Service
public class LifeServiceServiceImpl extends ServiceImpl<LifeServiceMapper, LifeService> implements ILifeServiceService {

    public void add(LifeService lifeService){
        lifeService.setStatus(0);
        save(lifeService);
    }

    public void update(LifeService lifeService){
        LifeService old = getById(lifeService.getServiceId());
        if(null == old){
            throw new APIException("不存在的生活服务");
        }
        lifeService.setStatus(0);
        updateById(lifeService);
    }

    public Page<LifeService> listByPage(NamePageDTO namePageDTO){
        LambdaQueryWrapper<LifeService> lambdaQueryWrapper = Wrappers.lambdaQuery();
        return baseMapper.selectPage(new Page<>(namePageDTO.getPage(), namePageDTO.getPageSize()),
                lambdaQueryWrapper.eq(!TextUtils.isEmpty(namePageDTO.getName()), LifeService::getName, namePageDTO.getName())
                        .eq(LifeService::getStatus, 1).orderByAsc(LifeService::getSort));
    }

    public void delete(Long id){
        LifeService old = getById(id);
        if(null == old){
            throw new APIException("不存在的生活服务");
        }
        removeById(id);
    }
}
