package com.smcic.api.admin.service.impl;

import com.smcic.api.admin.entity.LiveStream;
import com.smcic.api.admin.mapper.LiveStreamMapper;
import com.smcic.api.admin.service.ILiveStreamService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.smcic.core.advice.APIException;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 电视广播直播流地址管理 服务实现类
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@Service
public class LiveStreamServiceImpl extends ServiceImpl<LiveStreamMapper, LiveStream> implements ILiveStreamService {

    public void add(LiveStream liveStream) {
        save(liveStream);
    }

    public void update(LiveStream liveStream) {
        LiveStream exist = getById(liveStream.getLiveId());
        if (exist == null){
            throw new APIException("数据不存在");
        }
        updateById(liveStream);
    }

    public List<LiveStream> liveStreamList() {
        return list();
    }

    public void delete(Long liveId) {
        LiveStream liveStream = getById(liveId);
        if (liveStream == null){
            throw new APIException("数据不存在");
        }
        removeById(liveId);
    }
}
