package com.smcic.api.admin.service.impl;

import com.smcic.api.admin.entity.MenuModule;
import com.smcic.api.admin.entity.RoleAclModule;
import com.smcic.api.admin.mapper.MenuModuleMapper;
import com.smcic.api.admin.service.IMenuModuleService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@Service
public class MenuModuleServiceImpl extends ServiceImpl<MenuModuleMapper, MenuModule> implements IMenuModuleService {

    @Resource
    private RoleAclModuleServiceImpl roleAclModuleService;

    public void create(MenuModule menuModule) {
        this.save(menuModule);
    }

    // cms菜单
    public List<MenuModule> adminMenuModule(Long pid) {
        return lambdaQuery().eq(MenuModule::getType, 2). eq(MenuModule::getPid, pid).list()
                .stream().peek(menuModule -> {
                    menuModule.setChildren(adminMenuModule(menuModule.getModuleId()));
                }).collect(Collectors.toList());
    }

    public void delete(Long id) {
        MenuModule menuModule = this.getById(id);
        if (roleAclModuleService.lambdaQuery().eq(RoleAclModule::getModuleId, menuModule.getModuleId()).count() > 0) {
            throw new RuntimeException("该模块下有角色,无法删除");
        }
        this.removeById(id);
    }

    public void update(MenuModule menuModule) {
        this.updateById(menuModule);
    }

    // 客户端权限
    public List<MenuModule> clientMenuModule() {
        return lambdaQuery().eq(MenuModule::getType, 1).eq(MenuModule::getPid, 0).list();
    }
}
