package com.smcic.api.admin.service.impl;

import com.smcic.api.admin.entity.Region;
import com.smcic.api.admin.mapper.RegionMapper;
import com.smcic.api.admin.service.IRegionService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 * 地域表 服务实现类
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@Service
public class RegionServiceImpl extends ServiceImpl<RegionMapper, Region> implements IRegionService {

    public List<Region> regionTree(){
        List<Region> list = lambdaQuery().orderByAsc(Region::getRegionId).list();
        Map<Long, Region> group = list.stream().collect(Collectors.toMap(Region::getRegionId, region -> region));
        List<Region> rs = new ArrayList<>();
        for (Region region : list) {
            if (region.getPid() == 0) {
                rs.add(region);
            } else {
                Region parent = group.get(region.getPid());
                if (parent != null) {
                    if (parent.getChildren() == null) {
                        parent.setChildren(new ArrayList<>());
                    }
                    parent.getChildren().add(region);
                }
            }
        }

        return rs;
    }
}
