package com.smcic.core.auth;


import cn.hutool.core.util.StrUtil;
import com.smcic.core.advice.APIException;
import com.smcic.core.conf.Constant;
import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.AsyncHandlerInterceptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.Method;

public class LoginInterceptor implements AsyncHandlerInterceptor {
    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        if (!(handler instanceof HandlerMethod)) {
            return true;
        }

        HandlerMethod handlerMethod = (HandlerMethod) handler;
        Method method = handlerMethod.getMethod();

        LoginRequired methodAnnotation = method.getAnnotation(LoginRequired.class);
        if (methodAnnotation == null) {
            return true;
        }

        // 这写你拦截需要干的事儿，比如取缓存，SESSION，权限判断等
        String token = request.getHeader(Constant.TOKEN_HEADER_NAME);

        if (!AESUtil.isOk(token)) {
            throw new APIException("没有登录");
        }

        HttpContextUtil.setToken(token);

        return true;
    }
}
